;============================================================
;globally used macros and EXE VTable macros for new ActionTypes
;============================================================

;esi must be set up properly for this macro; eax is destroyed

MACRO GETPLAYERLOCADDR	{ ;returns pointer to three loc values in eax
mov eax,[LocationADDR]
mov eax,[eax]
mov eax,[eax+14h]	;main player location/other object
add eax,30h		;eax now points to 32-bit floats x,y,z positions
}			;directly in the executable

MACRO _CLOSEHANDLE _handle {
local nohandle
cmp _handle,0
jz nohandle
invoke CloseHandle,_handle
nohandle:
}

;====================================================================
;EXE-SPECIFIC V-TABLES FOR ALL DEFINED ACTIONTYPE CLASSES
;====================================================================
macro VTable_P6_1_1 mainproc {
 dd 0044CDB0h
 dd 0040FDC0h
 dd mainproc
 dd 00468A60h
 dd 0044AA60h
 dd 004F2F80h
 dd 004F2F80h
 dd 0
 dd 0
 dd 0
 }

macro VTable_K6_1_1 mainproc {
 dd 0044C9C0h
 dd 0040FC50h
 dd mainproc
 dd 004EAA20h
 dd 004BC160h
 dd 004EF9A0h
 dd 004EF9A0h
 dd 0
 dd 0
 dd 0
}

macro VTable_P5_Demo mainproc {
 dd 0044AAB0h
 dd 0040FB10h
 dd mainproc
 dd 00403210h
 dd 00448B80h
 dd 004F2CC0h
 dd 004F2CC0h
 dd 0
 dd 0
 dd 0
}

macro VTable_P5_1_1 mainproc {
 dd 0044CFD0h
 dd 0040FD60h
 dd mainproc
 dd 00403220
 dd 0044AC60h
 dd 0044AC70h
 dd 0044AC70h
 dd 0
 dd 0
 dd 0
}


