;============================================================
;saves any strings to dynamic buffer and stores string offset
;============================================================
;(applies to all strings, not only bitmaps, despite naming)
;from buffer start in DWORD [edi+8]
;-> DWORD [edi+8] = current string address upon jump

SAVE_STRING_MAIN:
mov edx,[edi+8] 	;bitmap name ADDR (source)
    test edx,edx
    jz ExitINAT		;if no bitmap, will not be loaded

	lea ecx,[edx-1]
	CountLoop_102_INAT:
	inc ecx
	cmp BYTE [ecx],0
	jnz CountLoop_102_INAT	;get length

	sub ecx,edx
	add ecx,1		;include null-terminator
	mov [ebp-4],ecx

	cmp [BMPNAMEALLOCBASE],0	;first T-Script-based bitmap string?
	jnz RE_ALLOC_ONLY_102

invoke LocalAlloc,LMEM_FIXED,ecx
	test eax,eax
	jz UnableToAllocateMem
	mov [BMPNAMEALLOCBASE],eax
	mov ecx,[ebp-4]
	mov [ALLOCSIZE],ecx
push esi
mov esi,[edi+8] 	;source string
mov DWORD [edi+8],0	;(first string in buffer relatively)

Final_Move_String_102:
	mov ecx,[ebp-4]
	push edi
	mov edi,eax
	rep movsb		;move string to new location
	pop edi
	pop esi
	jmp ExitINAT

RE_ALLOC_ONLY_102:
       mov eax,[ALLOCSIZE]
       push esi
       mov esi,[edi+8]
       mov [edi+8],eax	 ;replace old string addr by new in object (relative to bufferstart)

       add eax,[ebp-4]	       ;new buffer size (old size + new strlength)
       mov [ALLOCSIZE],eax
invoke LocalReAlloc,[BMPNAMEALLOCBASE],eax,LMEM_MOVEABLE
       test eax,eax
       jz UnableToAllocateMem
       mov [BMPNAMEALLOCBASE],eax
       add eax,[edi+8]
       jmp Final_Move_String_102
