;============================================================
;macros for new ActionType init
;============================================================


;registers eax,edi,ebp must be set properly for these macros

macro ALLOCAT _size {	;memory allocation
push _size
call [YAPAXI]		;allocates memory for instance
add esp,4
test eax,eax
jz UnableToAllocateMem
mov edi,eax		;store pointer in edi
}

MACRO GETVALUE EntryValue,_number {	;T-Script entry fetch
push _number		;edi and ebp must be set up properly
push DWORD [ebp-36]	;passed value of edi
push DWORD [ebp-32]	;passed value of esi
mov eax,[ebp-28]	;passed value of ebx
add eax,EntryValue	;table displacement for the T-Script value
push eax
call [GetEntryValueProc]
}

;retrieves and stores value from returned object
;_member is the member in the destination object

MACRO SETVALUE ValueType,_member {	
	local WrongValueType
	local NoObject
test eax,eax
jz NoObject
cmp DWORD [eax+4],ValueType
jnz WrongValueType
	if ValueType=value_string
        mov eax,[eax+40h]
	else
	mov eax,[eax+28h]	;if string, this is only string length
	end if			;if other value, this is direct value
mov [edi+((_member-1)*4)],eax

WrongValueType:
NoObject:
}				;eax has value if needed
