;MODIFIES PLAYER HEALTH
;object:
;DWORD [object] = VTable Pointer
;DWORD [object+4] = n/a
;DWORD [object+8] = hit points to substract from player health
;		    (0 for full health/heal fully)
;DWORD [object+12] = run once value
;       bit 0 = should be run only once?
;       bit 1 = has been run once? (only valid if bit 0 set)

AT104MAIN:

	cmp BYTE [ecx+12],3
	jz NoPlayerHealthChange_104

push esi
mov esi,[BaseData]

	or BYTE [ecx+12],2
	mov eax,[PLAYER_OBJ_INVUL_ADDR]	;also for INVUL cheat
	mov edx,[eax]			;edx='player' object

cmp DWORD [ecx+8],0
jz Full_Heal_104

	fld DWORD [edx+50h]		;current player health
	fsub DWORD [ecx+8]		;substract hit points
	fstp DWORD [edx+50h]		;store again

pop esi
NoPlayerHealthChange_104:
ret

Full_Heal_104:
	mov eax,[edx+54h]		;max player health (it seems)
	mov [edx+50h],eax
pop esi
ret
